<template>
    <h1>{{ title }}</h1>
    <p>{{counter}} times clicked</p>
    <button @click="increaseCounter">{{ text.increaseCounterText }}</button>
    <button v-on:click="increaseCounter">Increase Counter</button>

    <button>{{text.decreaseCounterText}}</button>

    <div tabindex="1" @keydown.ctrl.enter="increaseCounter">Keydown?</div>
    <div tabindex="1" v-on:keydown.ctrl.enter="increaseCounter">Keydown?</div>
</template>

<script setup>
    import {onBeforeUnmount, onMounted, ref} from "vue";

    //const props = defineProps(['title', 'text'])
    const props = defineProps({
        title: {
            type: String,
            required: true
        },
        text: {
            type: Object
        }
    })

    const counter = ref(3);
    // counter === {value: 3}

    /*const x = {firstName: 'Max', lastName: 'Muster'}
    const {firstName} = x
    console.log(firstName)*/

    function increaseCounter() {
        counter.value++;
        console.log(props.title)
        props.title = "test"

        props.text.increaseCounterText = 'Dingsbums'
    }

    function onWindowResize() {
        console.log('resize')
    }

    onMounted(() => {
        window.addEventListener('resize', onWindowResize)
    })

    onBeforeUnmount(() => {
        window.removeEventListener('resize', onWindowResize)
    })
</script>